about summary refs log tree commit diff
path: root/tools
diff options
context:
space:
mode:
Diffstat (limited to 'tools')
-rw-r--r--tools/default.nix1
-rw-r--r--tools/perf-flamegraph-pid/default.nix24
-rwxr-xr-xtools/perf-flamegraph-pid/perf-flamegraph-pid.sh20
3 files changed, 45 insertions, 0 deletions
diff --git a/tools/default.nix b/tools/default.nix
index 543882f..7003b8a 100644
--- a/tools/default.nix
+++ b/tools/default.nix
@@ -8,4 +8,5 @@ pkgs.lib.makeScope pkgs.newScope (pkgs: {
   git-blame-stats = pkgs.callPackage ./git-blame-stats { };
   git-broom = pkgs.callPackage ./git-broom { };
   sendsms = pkgs.callPackage ./sendsms { };
+  perf-flamegraph-pid = pkgs.callPackage ./perf-flamegraph-pid { };
 })
diff --git a/tools/perf-flamegraph-pid/default.nix b/tools/perf-flamegraph-pid/default.nix
new file mode 100644
index 0000000..d3b3e1e
--- /dev/null
+++ b/tools/perf-flamegraph-pid/default.nix
@@ -0,0 +1,24 @@
+{ lib, stdenvNoCC, pkgs, config }:
+
+stdenvNoCC.mkDerivation rec {
+  pname = "perf-flamegraph-pid";
+  src = ./perf-flamegraph-pid.sh;
+  version = "0.1.0";
+
+  nativeBuildInputs = with pkgs; [ flamegraph linuxPackages_latest.perf ];
+
+  dontUnpack = true;
+  dontBuild = true;
+
+  installPhase = ''
+    mkdir -p $out/bin
+    cp $src $out/bin/${pname}
+  '';
+
+  meta = with lib; {
+    description = "Generate a process' flame graph.";
+    license = with licenses; [ mit ];
+    platforms = platforms.unix;
+    maintainers = with maintainers; [ fcuny ];
+  };
+}
diff --git a/tools/perf-flamegraph-pid/perf-flamegraph-pid.sh b/tools/perf-flamegraph-pid/perf-flamegraph-pid.sh
new file mode 100755
index 0000000..141ceec
--- /dev/null
+++ b/tools/perf-flamegraph-pid/perf-flamegraph-pid.sh
@@ -0,0 +1,20 @@
+#!/usr/bin/env bash
+
+set -euo pipefail
+
+OUT_DIR="${HOME}/workspace/debug/flamegraph"
+OUT_DATA="${OUT_DIR}/$(date +%y%m%d-%H%M%S).data"
+OUT_SVG="${OUT_DIR}/$(date +%y%m%d-%H%M%S).svg"
+
+mkdir -p "${OUT_DIR}"
+
+# record the data with perf. We need to run this with sudo to get all
+# the privileges we need.
+sudo perf record -g --call-graph dwarf --freq max --output "${OUT_DATA}" "$@"
+
+# give me ownership of the file
+sudo chown "${USER}" "${OUT_DATA}"
+
+perf script --input "${OUT_DATA}" | \
+     stackcollapse-perf.pl | \
+     flamegraph.pl > "${OUT_SVG}"